import bpy

class OT_Copymtl(bpy.types.Operator):
    bl_idname = "nodefx.copy_mtl"
    bl_label = "Copy Material"
    bl_options = {'UNDO'}

    def execute(self, context):
        ob = context.object
        if ob and ob.material_slots:  # 检查物体是否有材质插槽
            for mtl in ob.material_slots:
                if mtl.material:  # 确保材质插槽有材质
                    material = mtl.material
                    # Duplicate the active material
                    new_mat = material.copy()
                    # Assign the duplicated material to the active slot
                    mtl.material = new_mat

        return {'FINISHED'}
