import bpy

# 用于更新属性面板中的 Geometry Nodes的group node 修改器属性

# def update_modifier_properties(context, layout):
#     obj = context.active_object
#     if obj and obj.modifiers:
#         # 筛选出所有名称以 "Geo_" 开头的 Geometry Nodes 修改器
#         geo_modifiers = [mod for mod in obj.modifiers if mod.name.startswith("Geo_") and mod.type == 'NODES']
#         for modifier in geo_modifiers:
#             box = layout.box()

#             # 尝试绘制可能存在的自定义按钮
#             try:
#                 if hasattr(modifier, "draw_buttons"):
#                     modifier.draw_buttons(context, box)
#                 elif hasattr(modifier, "draw_buttons_ext"):
#                     modifier.draw_buttons_ext(context, box)
#             except Exception as e:
#                 print("Error drawing buttons:", e)

#             # 检查是否存在节点组并操作其节点
#             if hasattr(modifier, "node_group") and modifier.node_group:
#                 node_group_box = box.box()

#                 # 遍历节点组中的所有节点，并筛选出前缀为 "Geo_" 的 GROUP 类型节点
#                 geo_group_nodes = [node for node in modifier.node_group.nodes if node.name.startswith("Geo_") and node.type == 'GROUP']
#                 for node in geo_group_nodes:
#                     node_box = node_group_box.box()
#                     node_box.label(text=f"Node: {node.name} (Type: {node.type})", icon='NODE')
                    
#                     # 展示每个 GROUP 节点的输入属性
#                     for socket in node.inputs:
#                         if hasattr(socket, 'default_value'):
#                             socket_row = node_box.row()
#                             socket_row.prop(socket, 'default_value', text=socket.name)


def draw_geo_modifier_properties(context, layout):
    obj = context.object
    if obj:
        # 筛选出所有名称以 "Geo_" 开头的 Geometry Nodes 修改器
        for modifier in [m for m in obj.modifiers if m.type == 'NODES' and m.name.startswith("Geo_")]:
            box = layout.box()
            box.label(text="Modifier: " + modifier.name, icon='NODETREE')
            
            # 基本信息
            row = box.row()
            row.prop(modifier, "name", text="Name")
            row.operator("object.modifier_remove", text="", icon='X').modifier = modifier.name
            
            row = box.row()

            # Geometry Nodes 特定设置
            if hasattr(modifier, "node_group") and modifier.node_group:
                box.prop(modifier, "node_group", text="Node Group")
                box.prop(modifier, "show_viewport", text="Display in Viewport")
                box.prop(modifier, "show_render", text="Use in Render")


                # Accessing node inputs via the node_group's nodes
                node_group_box = box.box()
                node_group_box.label(text="Node Group Inputs:")
                for node in modifier.node_group.nodes:
                    if hasattr(node, 'inputs'):
                        for input_socket in node.inputs:
                            if input_socket.identifier == hasattr(input_socket, 'default_value'):
                                row = node_group_box.row()
                                row.prop(input_socket, "default_value", text=input_socket.name)
