import bpy, os
import bpy.utils.previews
import webbrowser

#圖片位在Library/IMG/ui_icons/資料夾中
meiu_frosty_ice_tools_icon_path = os.path.join(os.path.dirname(os.path.dirname(__file__)), "Library/IMG/ui_icons")


meiu_frosty_ice_tools_global_icons = None

def meiu_frosty_ice_tools_open_webpage(url):
    webbrowser.open(url)

def meiu_frosty_ice_tools_load_icons():
    global meiu_frosty_ice_tools_global_icons
    if meiu_frosty_ice_tools_global_icons is None:  # 添加检查以防止重复加载图标
        meiu_frosty_ice_tools_global_icons = bpy.utils.previews.new()
        meiu_frosty_ice_tools_global_icons.load("meiu_logo", os.path.join(meiu_frosty_ice_tools_icon_path, "meiu.png"), 'IMAGE')
        meiu_frosty_ice_tools_global_icons.load("meiu_website", os.path.join(meiu_frosty_ice_tools_icon_path, "website.png"), 'IMAGE')
        meiu_frosty_ice_tools_global_icons.load("meiu_twitterx", os.path.join(meiu_frosty_ice_tools_icon_path, "twitterx.png"), 'IMAGE')
        meiu_frosty_ice_tools_global_icons.load("meiu_discord", os.path.join(meiu_frosty_ice_tools_icon_path, "discord.png"), 'IMAGE')

def meiu_frosty_ice_tools_clear_icons():
    global meiu_frosty_ice_tools_global_icons
    if meiu_frosty_ice_tools_global_icons:  # 添加检查以确保只有在图标已加载的情况下才进行清理
        bpy.utils.previews.remove(meiu_frosty_ice_tools_global_icons)
        meiu_frosty_ice_tools_global_icons = None  # 重置全局变量以防止再次错误引用


class MeiUInfo_Documents(bpy.types.Operator):
    """Open Documents"""  
    bl_idname = "info.frosty_ice_tools_documents"  
    bl_label = "MeiU_Frosty_Ice_Tools_Documents"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        meiu_frosty_ice_tools_open_webpage("https://blendermarket.com/products/205384/docs/?ref=1353")
        return {'FINISHED'}
    
class MeiUInfo_Website(bpy.types.Operator):
    """Open Website"""
    bl_idname = "frosty_ice_tools_info.website"  
    bl_label = "MeiU_Frosty_Ice_Tools_Website"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        meiu_frosty_ice_tools_open_webpage("https://meiu.art/")
        return {'FINISHED'}

class MeiUInfo_Twitter(bpy.types.Operator):
    """Open Twitter"""
    bl_idname = "frosty_ice_tools_info.twitter"  
    bl_label = "MeiU_Frosty_Ice_Tools_Twitter"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        meiu_frosty_ice_tools_open_webpage("https://twitter.com/MeiU800")
        return {'FINISHED'}
    
class MeiUInfo_Discord(bpy.types.Operator):
    """Open Discord"""
    bl_idname = "frosty_ice_tools_info.discord"  
    bl_label = "MeiU_Frosty_Ice_Tools_Discord"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        meiu_frosty_ice_tools_open_webpage("https://discord.gg/jU7Mj5F3bk")
        return {'FINISHED'}
    

    

    
class MeiUInfo_Panel(bpy.types.Panel):
    """Displays a panel in the N panel for quick access to BlackDeer Studio's resources"""
    bl_idname = "frosty_ice_tools_info.panel"
    bl_label = "MeiU_Info"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = 'Frosty Ice Tools'

    def draw_header(self, context):
        if meiu_frosty_ice_tools_global_icons:
            self.layout.label(text="", icon_value=meiu_frosty_ice_tools_global_icons["meiu_logo"].icon_id)

    def draw(self, context):

        layout = self.layout
        box = layout.box()
        row = box.row()
        row.operator("frosty_ice_tools_info.website", text="Website", icon_value=meiu_frosty_ice_tools_global_icons["meiu_website"].icon_id)
        row.operator("frosty_ice_tools_info.twitter", text="Twitter", icon_value=meiu_frosty_ice_tools_global_icons["meiu_twitterx"].icon_id)
        row.operator("frosty_ice_tools_info.discord", text="Discord", icon_value=meiu_frosty_ice_tools_global_icons["meiu_discord"].icon_id)

        box = layout.box()

        row = box.row()
        
        # 切換語言的按鈕
        row.operator("info.frosty_ice_tools_documents", text="Documents", icon='HELP')
        box.scale_y = 2
    
